VERSION HISTORY:
Audica 1	(08-04-19)
Audica 2	(08-04-20)
Audica 3	(08-04-21)
Audica 4 (pre)	(09-05-03)
Audica 4 dev	(09-08-20)
Audica 4 dev 3	(09-09-10)
Audica 4 dev 4	(09-09-13)
Audica 4 dev 5	(09-09-22)

(09-09-24)
-Поддержка многоканальных файлов.
-Изменения визуализации
-Циклическая прокрутка списков клавишами
(09-09-26)
-Поддержка Unicode в Drag'n'Drop операциях

Audica 4 dev 6	(09-09-26)

(09-09-26)
-Плавающая ширина визуализации
(09-09-27)
-FIX: mouseUp для прогресс-бара не происходит, если нажать Alt+Tab
Проверка GetCapture<>hwnd на mousemove(button=1), т.к. при альт-таб кэпче снимается и вызывается mousemove.
-FIX: Стереть hs-URL и отключить ласт.фм - Connected не исчезает
-FIX: плейлист lst_0.txt загружается даже при отсутствии options.ini
-FIX: каждая строка в плейлистах увеличивается на 1 байт после сохранении
Ошибка в midFromArr, при чтении строк их длина увеличивалась на 1 байт.
-FIX: ошибка при чтении плейлистов в ReadBytesFromFile и getItemFromArr
Из файла считывалось на 1 байт больше, это скрывало ошибки в getItemFromArr.
(09-09-28)
-Сохранение кеша прослушанных треков на случай, если не удалось сделать скробблинг до закрытия программы
-Окно About
(09-09-29)
-Авто-подбор ширины колонок в плейлистах, убраны заголовки
-Перемещение треков между плейлистами перетаскиванием
(09-09-30)
-Копирование путей к файлам из плейлистов по Ctrl+C (ANSI)
(09-10-01)
-Выделение следующего трека в плейлисте
(09-10-03)
-Custom-выделение в плейлисте, не отображается фокус-рамка
(09-10-04)
-Отображение номера выделенного трека и общего кол-ва треков в контекстном меню
-Меню быстрого поиска в плейлисте текущего и следующего треков
(09-10-05)
-FIX: выделение предыдущего играемого трека не снималось, например, если он в другом листе
(09-10-06)
-FIX: Поддержка libre.fm (BAD TIMESTAMP)
Неверно подсчитывалось время в UTC
(09-10-09)
-FIX: ошибка при загрузке неверного плейлист-файла
Из-за попытки считать отрицательное число байт
-Хранение имен плейлистов непосредственно в плейлист-файлах
-Удаление неиспользуемых плейлист-файлов
-Плейлист сохраняет адрес веб-сайта потока
(09-10-13)
-Специальный плейлист - Корзина. Хранит до закрытия программы удаленные из других плейлистов треки.
(09-10-18)
-Мигание светодиодами на PS/2 клавиатуре в такт музыке

Audica 4 dev 7	(09-10-18)

(09-10-20)
-Изменено управление табами. DoubleClk - создать, MiddleClk - удалить, RightClick - меню: удалить, переименовать.
(09-10-22)
-Поддержка Unicode при добавлении файлов через диалог открытия
-Увеличена скорость копирования путей к файлам в буфер (~28 раз). Добавлена поддержка Unicode.
(09-10-27)
-FIX: проблемы с реакцией на нажатия клавиш во время мигания диодами.
Перестаёт мигать при любой нажатой клавише (хук клавиатуры).
-Можно установить параметры эквалайзера при отсутствии играемого трека.
(09-10-31)
-OwnerData в плейлистах.
(09-11-01)
-Сохранение текущего трека для каждого списка в файл плейлиста.
-Запуск последнего трека после загрузки программы (опционально).
(09-11-10)
-Изменения дизайна вкладок.
(09-11-12)
-FIX: Поправлена позиция отрисовки оставшегося времени.
(09-11-15)
-FIX: верное отображение символа "&" в информации о треке
(09-11-22)
-FIX: Захват курсора при перетаскивании элементов
-Скролл списка вверх/вниз при перетаскивании элементов
(09-11-26)
-FIX: Если в плейлисте нет текущего трека, то при старте Audica будет запущен следующий.
-Сортировка плейлистов мышью.
(09-11-27)
-Кнопки Стоп, Пауза заменены на универсальную: Play(не проигрывается), Pause(проигрывается), Stop(проигрывается поток)
(09-11-29)
-Изменение громкости с помощью SHift+Wheel
-Клик правой кнопкой по универсальной кнопке - Stop для потоков и локальных файлов.

Audica 4	(09-11-29)

(09-11-29)
-FIX: Поддержка drag'n'drop папок с Unicode именами
-FIX: Поддержка Unicode в командной строке (напр. открытие файлов через Проводник)
(09-12-03)
-Поддержка обложек с помощью FreeImage. Обложки загружаются из ID3V2 тегов или файлов cover на диске.
Допускаются имена cover.jpg, cover.jpeg, cover.png, cover.gif, cover.bmp
-Автоматическая установка фокуса на плейлист при прокрутке колесом мыши (без Shift).
-Управление громкостью колесом мыши без Shift, если фокус в Audica и курсор за пределами плейлиста.
(09-12-07)
-Настоящий OwnerData в плейлистах.
Предыдущий был эмуляцией:)
-Отображение названия альбома и номера трека в плейлисте
-FIX: Обложка из ID3V2 читалась не полностью.
-Текущий трек виден в плейлисте сразу при запуске плеера.
(09-12-08)
-Сортировка треков по Названию, Исполнителю, Альбом и Номеру трека, Пути
-Улучшено качество рисования при уменьшении размера обложки
(09-12-10)
-Поиск по плейлисту (ANSI)
-Если URL введен без указания протокола, то автоматически подставляется "http://".
-FIX: загрузка трека прекращалась при попытке считать неверный фрейм APIC из ID3V2.
(09-12-11)
-Улучшено перетаскивание внутри плейлиста.
(09-12-12)
-Увеличение картинки при нажатии на обложку.
-В качестве обложек поддерживаются файлы с именами "*AlbumArt*".
(09-12-13)
-Запуск воспроизведения кнопкой Play/Pause на клавиатуре
(09-12-17)
-Хук клавиатуры и мыши вынесен в инструмент hooktool.
Избавляет от необходимости снимать хук на длительных операциях.
-Надпись "AUDICA" при отсутствии играемого трека.
(09-12-19)
-Использование Dictionary вместо Collection для хранения треков.
Ускоряет сортировку в ~1.5-2 раза.
-Вставка элементов в список при перетаскивании из Проводника.
Ранее они добавлялись в конец списка.
-FIX: если запустить трек в последнем плейлисте и закрыть его, то на следующем треке происходит падение.
Выполнялось обращение к списку с неверным индексом.
-Небольшое ускорение сортировки за счёт использования числовых ключей.
(09-12-29)
-FIX: Поправка играемого трека при вставке/удалении элементов.
(09-12-30)
-Всплывающие подсказки для частично видимых полей в плейлистах.
-Кнопка дальнейшего поиска (>) заменена клавишей Enter или F3.
(10-01-02)
-Уменьшено мерцание при изменении ширины плейлиста.
-FIX: Верное выделение кнопок R и D при открытии файла через Проводник.
(10-01-04)
-Поддержка Unicode в поле поиска по плейлисту.
-FIX: При переключении треков и открытом диалоге добавления файлов могло произойти падение.
Диалог изменяет текущий каталог, поэтому программа не находит FreeImage (нужно загружать его с помощью LoadLibrary).
-Копирование треков между плейлистами при удержании Ctrl.
(10-01-05)
-Окно с информацией о композиции и громкости (интерфейс требует доработки).
Отображается на 3с при запуске трека, на 1с при изменении громкости, если фокус вне программы.
(10-01-10)
-Переписан код работы с удаленными источниками (добавлена пребуферизация и пр.)
(10-01-11)
-Получение OGG тегов интернет-потоков.
(10-01-12)
-FIX: После падения программы и последующего запуска, hooktool не подключался к основной программе.
(10-01-13)
-Увеличена стабильность при подключении к интернет-потоку за счет блокирования программы.
-Визуализация - управление цветом Aero (если доступно) в такт музыке.
-FIX: Верные пропорции обложек в окне информации.
-FIX: Ошибка при запуске из панели Windows 7 - сбой инициализации BASS.
В качестве главного окна передавать BASS информационное окно, а не 0.


TODO:
-Фоновое сканирование тегов
-Регистрация типов файлов
+Поддержка Unicode при добавлении файлов через диалог
-Эквалайзер
+Хранение названий плейлистов в файлах плейлистов
-Улучшение консоли: фильтр по типам событий, больший выбор цветов
+Сохранение кеша треков для скробблинга
+FIX: плейлист lst_0.txt загружается даже при отсутствии options.ini
Мин. кол-во плейлистов в настройках = 0
+FIX: поддержка libre.fm (BAD TIMESTAMP; turtle.libre.fm)
Timestamp в UTC.
+FIX: Стереть hs-URL и отключить ласт.фм - Connected не исчезает
Проверять в isOnline не только CONNECTED, но и disabled
+Запоминать текущий трек при выходе
+FIX: mouseUp для прогресс-бара не происходит, если нажать Alt+Tab
+Стирать неиспользуемые файлы плейлистов
?Название радиостанции на русском отображается неверно
Использовать ANSI. Полностью ли верное решение, неизвестно.
-Отображение реального битрейта интернет-потоков
-Загрузка лирики
+Объединить ListView и Playlist collection (09-10-01)
+Посмотреть еще раз получение выделенных элементов
Поправлено - без перебора всех элементов
-Поддержка M3U \ PLS
+Не запоминает офф. сайт потоков
+Перетаскивание плейлистов
+FIX: tabs.playing.slotChannelStopped ошибка при отсутствии playing
Если запустить трек в последнем плейлисте и закрыть его, то на следующем треке происходит падение.
+Возобновление воспроизведения после загрузки
+Поиск по плейлисту
+Исправить перетаскивание элементов в плейлисте с учетом OwnerData
+Улучшить код, относящийся к хукам клавиатуры, мыши
+Отображать в плейлисте номера треков вместо размера
+Исправлять введенный URL (подставлять http://)
?FIX: Сбрасывается флаг default
?Drag-n-Drop файлов из программы.
+FIX: Поправка играемого трека при вставке/удалении элементов.
?Значения слайдеров - Single от 0 до 1.
+FreeImage not found при открытом диалоге открытия файлов
-Доработать окно с информацией о треке / громкости
-Цветовая схема
-Интерфейс добавления источников
-Хоткеи Shift+Вправо\Влево, Shift+Pause
?Запись интернет-потоков.
-Скобблинг композиций из интернет-потоков.
?Обложки ogg интернет-потоков
?инфо-окно - popup

6269 из 66939 файлов в 6285 папках - 37.471с